#ifndef _MISC_WASTED_SETTINGS_HPP_
#define _MISC_WASTED_SETTINGS_HPP_

// ------------------------------------------------------------------------------------------------
#include "Common.hpp"
#include "Base/Color3.hpp"

// ------------------------------------------------------------------------------------------------
namespace SqMod {

/* ------------------------------------------------------------------------------------------------
 * ...
*/
struct CWastedSettings
{

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    typedef SQUnsignedInteger32 U32;
    typedef SQFloat F32;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    U32 DeathTimer, FadeTimer;
    F32 FadeInSpeed, FadeOutSpeed;
    Color3 FadeColor;
    U32 CorpseFadeStart, CorpseFadeTime;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings(U32 dt, U32 ft, F32 fis, F32 fos, const Color3 & fc, U32 cfs, U32 cft);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings(const CWastedSettings & x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings(CWastedSettings && x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    ~CWastedSettings();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings & operator= (const CWastedSettings & x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings & operator= (CWastedSettings && x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings operator+ (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings operator- (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings operator* (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWastedSettings operator/ (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator== (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator!= (const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    SQInteger Cmp(const CWastedSettings & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Get() const;
};


} // Namespace:: SqMod

#endif // _MISC_WASTED_SETTINGS_HPP_